#include <iostream>
#include <fstream>
#include <sstream>
#include <stdio.h>
#include <cstring>
#include <map>
#include <string>
#include <vector>

using namespace std;

int main(int argc, char *argv[])
{
	char alphabet[20] = {'a', 'r', 'd', 'c', 'q', 'e', 'h', 'i', 'g', 'n', 'l', 'k', 'm', 'f', 'p', 's', 't', 'w', 'y', 'v'};
	string data[54];
	vector<string> sequence;
	map<string, int> amino;
	string tmp, seq, str;
	vector<string> gram(20);
	int max;
	ifstream inf;
	ofstream outf;
	
	if(argc<4)
	{
		cout<<"usage: [program name] [max distance] [input protein sequence file in FASTA format] [output feature vector file]"<<endl;
		return 0;
	}

	str = argv[1];
	max = atoi(str.c_str());

	inf.open(argv[2]);
    if (!inf) 
	{
		cout << "Input file does not exist!" << endl;
    }
	else
	{
	    
		istringstream istr;
		string str, tmp1 = "", tmp2 = "";
		while(getline(inf, str))
		{
			istr.str(str);
			if(str.find(">") != -1)
			{
				if(tmp1 != "")
				{
					sequence.push_back(tmp2);
				}
				istr >> tmp1;
				tmp2 = "";
			}
			else
			{
				tmp2 = tmp2 + str;
			}
		}	
		sequence.push_back(tmp2);
	}
	inf.close();

	for(int i = 0; i < 20; i++)
	{
		gram[i] = "x";
		gram[i][0] = alphabet[i];
		amino.insert(map<string, int> :: value_type(string(gram[i]), i));
	}

	outf.open(argv[3]);
	if(!outf){
		outf.open("Output.txt");
	}
	for(int m = 0; m < sequence.size(); m++)
	{
	    vector<int> gram_featureVector(20 * 20 * max + 20, 0);
		string test = sequence[m];
	    for(int i = 0; i < test.length(); i++)
		{
		    gram_featureVector[amino[test.substr(i, 1)]] += 1;
	    }
		for(int d = 1; d <= max && d < test.length(); d++)
		{
            for(int i = 0; i < test.length() - d; i++)
			{
                gram_featureVector[20 + (d - 1) * 20 * 20 + amino[test.substr(i, 1)] * 20 + amino[test.substr(i + d, 1)]] += 1;
			}
	    }
		stringstream s;
		string tmp = "";
		s << gram_featureVector[0];
		s >> tmp;
		for(int j = 1; j < 20 * 20 * max + 20; j++)
		{
			stringstream ss;
		    string str;
		    ss << gram_featureVector[j];
		    ss >> str;
			tmp = tmp + "\t" + str;
		}
		gram_featureVector.clear();
		outf << tmp << endl;
	}
	outf.close();

	return 0;
}